#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll n, q, a[100010], bits[32];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin>>n;
    for(int i=1; i<=n; i++)cin>>a[i];
    for(ll i=0; i<32; i++)
    {
        for(int j=1; j<=n; j++)
        {
            if((a[j]&((ll)1<<i))!=0)bits[i]++;
        }
    }
    cin>>q;
    while(q--)
    {
        int t; cin>>t;
        if(t==0)
        {
            int x; cin>>x;
            ll rez=0;
            for(ll i=0; i<32; i++)
            {
                if(bits[i]>=x)rez+=((ll)1<<i);
            }
            cout<<rez<<"\n";
        }
        else
        {
            ll x, y; cin>>x>>y;
            for(ll i=0; i<32; i++)
            {
                if((a[x]&((ll)1<<i))==0 and (y&((ll)1<<i))!=0)bits[i]++;
                else if((a[x]&((ll)1<<i))!=0 and (y&((ll)1<<i))==0)bits[i]--;
            }
            a[x]=y;
        }
    }
    return 0;
}